#!/bin/ksh
# ******************************************************************************************************************************
# * Licensed Materials - Property of IBM                                                                                       *
# * (c) Copyright IBM Corp. 2008, 2009 All Rights Reserved.                                                                    *
# *                                                                                                                            *
# *US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp*
# ******************************************************************************************************************************

rcrdone(){
echo $MESSAGE.$ACTION:$EXITCODE
echo $CRRRDECH002$
exit $EXITCODE
}

validate() {

if [ -z $CURINST ] 
then
	EXITCODE=$CRRRD4501E
	MESSAGE=$CRRRDMSGE001
	rcrdone
fi  

if [ -z $DBNAME ] 
then
	EXITCODE=$CRRRD4502E
	MESSAGE=$CRRRDMSGE002
	rcrdone
fi

if [ -z $DBUSER ] 
then
	EXITCODE=$CRRRD4503E
	MESSAGE=$CRRRDMSGE003
	rcrdone
fi

if [ -z $DBPASSWD ] 
then
	EXITCODE=$CRRRD4504E
	MESSAGE=$CRRRDMSGE004
	rcrdone
fi

if [ -z $NF_SCHEMA ] 
then
	EXITCODE=$CRRRD4505E
	MESSAGE=$CRRRDMSGE005
	rcrdone
fi

if [ -z $STAR_SCHEMA ] 
then
	EXITCODE=$CRRRD4506E
	MESSAGE=$CRRRDMSGE006
	rcrdone
fi

if [ -z $REP_USER ] 
then
	EXITCODE=$CRRRD4507E
	MESSAGE=$CRRRDMSGE007
	rcrdone
fi

if [ $DBUSER == $REP_USER ]
then
	EXITCODE=$CRRRD4595E
	MESSAGE=$CRRRDMSGE095
	rcrdone
fi

if [ -z $DATA_HOME ] 
then
	EXITCODE=$CRRRD4508E
	MESSAGE=$CRRRDMSGE008
	rcrdone
fi

if [ -z $START_YEAR  ] 
then
	EXITCODE=$CRRRD4509E
	MESSAGE=$CRRRDMSGE009
	rcrdone
fi


if [ -z $END_YEAR ] 
then
	EXITCODE=$CRRRD4510E
	MESSAGE=$CRRRDMSGE010
	rcrdone
fi




if [ -z $LANG ]
then
	EXITCODE=$CRRRD4585E
	MESSAGE=$CRRRDMSGE085
	rcrdone
fi




rcrdone
}

createdb() {
#echo "$JAVACMD $DERBY_OPTS -classpath $LOCALCLASSPATH -Dij.outfile=$CD/logs/createdb.log org.apache.derby.tools.ij $CD/work_spc/createDB/createdb.sql"
CMD="$JAVACMD $DERBY_OPTS -classpath $LOCALCLASSPATH -Dij.outfile=$CD/logs/createdb.log org.apache.derby.tools.ij $CD/work_spc/createDB/createdb.sql"
$CMD
grep -e "ERROR " $CD/logs/createdb.log >/dev/null

if [ $? -eq 0 ]
then
	MESSAGE=$CRRRDMSGE013  
	EXITCODE=$CRRRD4513E
	ACTION=$CRRRDECH003
	rcrdone
fi


}

if [ -f set_env.sh ]
then 
	. ./set_env.sh
else 
	EXITCODE=4597
	MESSAGE=XXX
	ACTION=x
	rcrdone	
fi

if [ -z $JAVA_HOME ]
then 
	EXITCODE= 4596
	MESSAGE=XXX
	ACTION=x
	rcrdone
fi

if [ ! -d $JAVA_HOME/bin ]
then
	EXITCODE=4596
	MESSAGE=XXX
	ACTION=x
	rcrdone	
fi

if [ ! -f $JAVA_HOME/bin/java ]
then
	EXITCODE=4598
	MESSAGE=XXX
	ACTION=x
	rcrdone	
fi

chmod -R +x lang

if [ "`echo $LANG | sed 's/\([a-z]*\).*/\1/'`" == "en" ]
then 
     LOCALE="en"
	. lang/en/messages.sh
fi	

if [ "`echo $LANG | sed 's/\([a-z]*\).*/\1/'`" == "it" ]
then 
	LOCALE="it"
	. lang/it/messages.sh
fi	

if [ "`echo $LANG | sed 's/\([a-z]*\).*/\1/'`" == "pl" ]
then 
	LOCALE="pl"
	. lang/pl/messages.sh
fi	

if [ "`echo $LANG | sed 's/\([a-z]*\).*/\1/'`" == "ko" ]
then 
	LOCALE="kr"
	. lang/kr/messages.sh
fi

if [ "`echo $LANG | sed 's/\([a-z]*\).*/\1/'`" == "ja" ]
then 
	LOCALE="ja"
	. lang/ja/messages.sh
fi

if [ "`echo $LANG | sed 's/\([a-z]*_[A-Z][A-Z]\).*/\1/'`" == "zh_CN" ]
then 
	LOCALE="zh_CN"
	. lang/zh_CN/messages.sh
fi

if [ "`echo $LANG | sed 's/\([a-z]*_[A-Z][A-Z]\).*/\1/'`" == "zh_TW" ]
then 
	LOCALE="zh_TW"
	. lang/zh_TW/messages.sh
fi

if [ "`echo $LANG | sed 's/\([a-z]*\).*/\1/'`" == "de" ]
then 
	LOCALE="de"
	. lang/de/messages.sh
fi	

if [ "`echo $LANG | sed 's/\([a-z]*\).*/\1/'`" == "es" ]
then 
	LOCALE="es"
	. lang/es/messages.sh
fi	

if [ "`echo $LANG | sed 's/\([a-z]*\).*/\1/'`" == "fr" ]
then 
	LOCALE="fr"
	. lang/fr/messages.sh
fi

if [ "`echo $LANG | sed 's/\([a-z]*_[A-Z][A-Z]\).*/\1/'`" == "pt_BR" ]
then 
	LOCALE="pt_BR"
	. lang/pt_BR/messages.sh
fi

if [ "`echo $LANG | sed 's/\([a-z]*\).*/\1/'`" == "ru" ]
then 
	LOCALE="ru"
	. lang/ru/messages.sh
fi

if [ "`echo $LANG | sed 's/\([a-z]*\).*/\1/'`" == "hu" ]
then 
	LOCALE="hu"
	. lang/hu/messages.sh
fi

if [ "`echo $LANG | sed 's/\([a-z]*\).*/\1/'`" == "cs" ]
then 
	LOCALE="cs"
	. lang/cs/messages.sh
fi

if [ -z "$LOCALE" ]
then
	 LOCALE="en"
	. lang/en/messages.sh
fi	


SILENT=0
FLAG_SCHEMA=0
MESSAGE="No errors"
ACTION=""
EXITCODE=0

if [ $# -eq 1 ]
	then 
	if [ $1 = "-silent" ]
	then
			SILENT=1
	else 
			SILENT=0
	fi
fi

if [ $# -eq 1 ]
	then
	if [ $1 = "-validate" ]
		then
		   validate
	fi
fi	

if [ $# -eq 1 ]
then
	if [ $1 = "-schema" ]
	 then
	        FLAG_SCHEMA=1
	else 
		FLAG_SCHEMA=0
	fi
fi

if [ $# -eq 2 ]
then
	if [ $1 = "-schema" ]
	 then
	        FLAG_SCHEMA=1
	fi
	if [ $2 = "-schema" ]
	 then
	        FLAG_SCHEMA=1
	 else
	 		FLAG_SCHEMA=0
	fi
fi


if [ $SILENT -eq 0 ]
then 
	. ./parameters.sh
fi	

if [ -z $JAVA_HOME ]
then
	MESSAGE=$CRRRDMSGE096
	EXITCODE=$CRRRD4596E
	rcrdone
fi

if [ -z $DBNAME ]
then
	MESSAGE=$CRRRDMSGE002
	EXITCODE=$CRRRD4502E
	rcrdone
fi

if [ -z $DBUSER ]
then
	MESSAGE=$CRRRDMSGE003
	EXITCODE=$CRRRD4503E
	rcrdone
fi

if [ $SILENT -eq 0 ]
then 
	echo $CRRRDPRMPT004
	read DBPASSWD
fi

if [ -z $DBPASSWD ]
then
	MESSAGE=$CRRRDMSGE004
	EXITCODE=$CRRRD4504E
	rcrdone
fi

if [ -z $NF_SCHEMA ]
then
	MESSAGE=$CRRRDMSGE005
	EXITCODE=$CRRRD4505E
	rcrdone
fi

if [ -z $STAR_SCHEMA ]
then
	MESSAGE=$CRRRDMSGE006
	EXITCODE=$CRRRD4506E
	rcrdone
fi

if [ -z $CALM_SCHEMA ]
then
	MESSAGE=$CRRRDMSGE107
	EXITCODE=$CRRRD4607E
	rcrdone
fi

if [ -z $RIASSET_SCHEMA ]
then
	MESSAGE=$CRRRDMSGE110
	EXITCODE=$CRRRD4610E
	rcrdone
fi

if [ -z $RISCHK_SCHEMA ]
then
	MESSAGE=$CRRRDMSGE115
	EXITCODE=$CRRRD4615E
	rcrdone
fi

if [ -z $REP_USER ]
then
	MESSAGE=$CRRRDMSGE007
	EXITCODE=$CRRRD4507E
	rcrdone
fi

if [ $SILENT -eq 0 ]
then 
	echo $CRRRDPRMPT022
	read REP_PASSWD
fi

if [ -z $REP_PASSWD ]
then
	MESSAGE=$CRRRDMSGE044
	EXITCODE=$CRRRD4544E
	rcrdone
fi

if [ $DBUSER == $REP_USER ]
then
	EXITCODE=$CRRRD4595E
	MESSAGE=$CRRRDMSGE095
	rcrdone
fi

if [ -z $DATA_HOME ]
then
	MESSAGE=$CRRRDMSGE008
	EXITCODE=$CRRRD4508E
	rcrdone
fi



if [ -z $START_YEAR ]
then
	MESSAGE=$CRRRDMSGE009
	EXITCODE=$CRRRD4509E
	rcrdone
fi

if [ -z $END_YEAR ]
then
	MESSAGE=$CRRRDMSGE010
	EXITCODE=$CRRRD4510E
	rcrdone
fi

. $DERBY_HOME/bin/derby_common.sh
JAVACMD=$JAVA_HOME/bin/java
LOCALCLASSPATH=$DERBY_HOME/lib/derby.jar:$DERBY_HOME/lib/derbynet.jar:$DERBY_HOME/lib/derbytools.jar:$DERBY_HOME/lib/derbyclient.jar

CONNSTR="$JAVACMD -classpath $LOCALCLASSPATH -Dij.connection.insight=jdbc:derby:$DATA_HOME/$DBNAME;create=false;user=$DBUSER;password=$DBPASSWD"
#echo $CONNSTR
if [ $SILENT -eq 1 ]
then 
	$CONNSTR 
	if [ $? -eq 0 ]
	then
		rcrdone
	fi
fi	


CD=`pwd`

if [ ! -d $CD/work_spc ]
then
	mkdir $CD/work_spc
else
	rm -fr $CD/work_spc
	mkdir $CD/work_spc
fi	
if [ $? -ne 0 ]
then
	MESSAGE=$CRRRDMSGE076
	EXITCODE=$CRRRD4576E
	rcrdone
fi
    

if [ ! -d $CD/logs ]
then
	mkdir $CD/logs
else
	rm -fr $CD/logs
	mkdir $CD/logs	
fi
if [ $? -ne 0 ]
then
	MESSAGE=$CRRRDMSGE076
	EXITCODE=$CRRRD4576E
	rcrdone
fi
echo $DATA_HOME/|sed 's/\//\\\//g'>tmp1.txt


cp -r ./createDB $CD/work_spc
if [ $? -ne 0 ]
then
	MESSAGE=$CRRRDMSGE024
	EXITCODE=$CRRRD4524E
	rcrdone
fi

cp -r ./ddl $CD/work_spc
if [ $? -ne 0 ]
then
	MESSAGE=$CRRRDMSGE024
	EXITCODE=$CRRRD4524E
	rcrdone
fi
cp -r ./scripts $CD/work_spc
if [ $? -ne 0 ]
then
	MESSAGE=$CRRRDMSGE024
	EXITCODE=$CRRRD4524E
	rcrdone
fi

cat ./createDB/createdb.sql|sed -e "s/\$DBNAME/`echo $DBNAME`/g"|sed -e "s/\$DATA_HOME/`cat tmp1.txt`/g"|sed -e "s/\$DBPASSWD/`echo $DBPASSWD`/g"|sed -e "s/\$DBUSER/`echo $DBUSER`/g" >$CD/work_spc/createDB/createdb.sql
cat ./createDB/createUsers.sql|sed -e "s/\$REP_USER/`echo $REP_USER`/g"|sed -e "s/\$REP_PASSWD/`echo $REP_PASSWD`/g"|sed -e "s/\$DBPASSWD/`echo $DBPASSWD`/g"|sed -e "s/\$DBUSER/`echo $DBUSER`/g">$CD/work_spc/createDB/createUsers.sql

cat ./ddl/createNF.ddl|sed -e "s/\$NF_SCHEMA/`echo $NF_SCHEMA`/g" > $CD/work_spc/ddl/createNF.ddl
cat ./scripts/initNF.sql|sed -e "s/\$NF_SCHEMA/`echo $NF_SCHEMA`/g" > $CD/work_spc/scripts/initNF.sql
cat ./ddl/createSTAR.ddl|sed -e "s/\$STAR_SCHEMA/`echo $STAR_SCHEMA`/g" > $CD/work_spc/ddl/createSTAR.ddl
cat ./ddl/createSTARViews.ddl|sed -e "s/\$NF_SCHEMA/`echo $NF_SCHEMA`/g"|sed -e "s/\$RIASSET/`echo $RIASSET_SCHEMA`/g"|sed -e "s/\$STAR_SCHEMA/`echo $STAR_SCHEMA`/g"|sed -e "s/\$RISCHK/`echo $RISCHK_SCHEMA`/g"> $CD/work_spc/ddl/createSTARViews.ddl
cat ./scripts/initSTAR.sql|sed -e "s/\$STAR_SCHEMA/`echo $STAR_SCHEMA`/g" > $CD/work_spc/scripts/initSTAR.sql
cat ./ddl/createCALM.ddl|sed -e "s/\$CALM_SCHEMA/`echo $CALM_SCHEMA`/g"|sed -e "s/\$NF_SCHEMA/`echo $NF_SCHEMA`/g" > $CD/work_spc/ddl/createCALM.ddl
cat ./scripts/initCALM.sql|sed -e "s/\$CALM_SCHEMA/`echo $CALM_SCHEMA`/g" > $CD/work_spc/scripts/initCALM.sql
cat ./ddl/createCALMViews.ddl|sed -e "s/\$NF_SCHEMA/`echo $NF_SCHEMA`/g"|sed -e "s/\$CALM_SCHEMA/`echo $CALM_SCHEMA`/g"> $CD/work_spc/ddl/createCALMViews.ddl
cat ./ddl/createRIASSET.ddl|sed -e "s/\$NF_SCHEMA/`echo $NF_SCHEMA`/g"|sed -e "s/\$RIASSET/`echo $RIASSET_SCHEMA`/g"> $CD/work_spc/ddl/createRIASSET.ddl
cat ./ddl/createRISCHK.ddl|sed -e "s/\$NF_SCHEMA/`echo $NF_SCHEMA`/g"|sed -e "s/\$RISCHK/`echo $RISCHK_SCHEMA`/g"> $CD/work_spc/ddl/createRISCHK.ddl
cat ./scripts/initRIASSET.sql|sed -e "s/\$RIASSET/`echo $RIASSET_SCHEMA`/g" > $CD/work_spc/scripts/initRIASSET.sql
cat ./scripts/initRISCHK.sql|sed -e "s/\$RISCHK/`echo $RISCHK_SCHEMA`/g" > $CD/work_spc/scripts/initRISCHK.sql
cat ./scripts/star_grants.sql|sed -e "s/\$STAR_SCHEMA/`echo $STAR_SCHEMA`/g"|sed -e "s/\$REP_USER/`echo $REP_USER`/g"> $CD/work_spc/scripts/star_grants.sql
cat ./scripts/calm_grants.sql|sed -e "s/\$CALM_SCHEMA/`echo $CALM_SCHEMA`/g"|sed -e "s/\$REP_USER/`echo $REP_USER`/g"> $CD/work_spc/scripts/calm_grants.sql
cat ./createDB/createSchema.sql|sed -e "s/\$NF_SCHEMA/`echo $NF_SCHEMA`/g"|sed -e "s/\$STAR_SCHEMA/`echo $STAR_SCHEMA`/g"|sed -e "s/\$CALM_SCHEMA/`echo $CALM_SCHEMA`/g"|sed -e "s/\$RIASSET/`echo $RIASSET_SCHEMA`/g"|sed -e "s/\$RISCHK/`echo $RISCHK_SCHEMA`/g" >$CD/work_spc/createDB/createSchema.sql

if [ $FLAG_SCHEMA -eq 0 ]
then 
	createdb
fi	




$CONNSTR -Dij.outfile=./logs/createSTGCFG.log org.apache.derby.tools.ij ./work_spc/ddl/createSTGCFG.ddl 
grep -e "ERROR " $CD/logs/createSTGCFG.log>/dev/null
if [ $? -eq 0 ]
then
	MESSAGE=$CRRRDMSGE016
	EXITCODE=$CRRRD4516E
	ACTION=$CRRRDECH006
	rcrdone
fi

$CONNSTR -Dij.outfile=./logs/createNF.log  org.apache.derby.tools.ij ./work_spc/ddl/createNF.ddl
grep -e "ERROR " $CD/logs/createNF.log>/dev/null
if [ $? -eq 0 ]
then
	MESSAGE=$CRRRDMSGE017
	EXITCODE=$CRRRD4517E
	ACTION=$CRRRDECH007
	rcrdone
fi

$CONNSTR -Dij.outfile=./logs/createSTAR.log  org.apache.derby.tools.ij ./work_spc/ddl/createSTAR.ddl
grep -e "ERROR " $CD/logs/createSTAR.log>/dev/null
if [ $? -eq 0 ]
then
	MESSAGE=$CRRRDMSGE018
	EXITCODE=$CRRRD4518E
	ACTION=$CRRRDECH008
	rcrdone
fi

$CONNSTR -Dij.outfile=./logs/createCALM.log  org.apache.derby.tools.ij ./work_spc/ddl/createCALM.ddl
grep -e "ERROR " $CD/logs/createCALM.log>/dev/null
if [ $? -eq 0 ]
then
	MESSAGE=$CRRRDMSGE108
	EXITCODE=$CRRRD4608E
	ACTION=$CRRRDECH035
	rcrdone
fi

$CONNSTR -Dij.outfile=./logs/createRIASSET.log org.apache.derby.tools.ij ./work_spc/ddl/createRIASSET.ddl 
grep -e " ERROR " $CD/logs/createRIASSET.log>/dev/null
if [ $? -eq 0 ]
then
	MESSAGE=$CRRRDMSGE111
	EXITCODE=$CRRRD4611E
	ACTION=$CRRRDECH037
	rcrdone
fi

$CONNSTR -Dij.outfile=./logs/createRISCHK.log org.apache.derby.tools.ij ./work_spc/ddl/createRISCHK.ddl
grep -e " ERROR " $CD/logs/createRISCHK.log>/dev/null
if [ $? -eq 0 ]
then
	MESSAGE=$CRRRDMSGE113
	EXITCODE=$CRRRD4613E
	ACTION=$CRRRDECH039
	rcrdone
fi

$CONNSTR -Dij.outfile=./logs/createSTARViews.log org.apache.derby.tools.ij ./work_spc/ddl/createSTARViews.ddl 
grep -e "ERROR " $CD/logs/createSTARViews.log>/dev/null
if [ $? -eq 0 ]
then
	MESSAGE=$CRRRDMSGE019
	EXITCODE=$CRRRD4519E
	ACTION=$CRRRDECH009
	rcrdone
fi

$CONNSTR -Dij.outfile=./logs/createCALMViews.log org.apache.derby.tools.ij ./work_spc/ddl/createCALMViews.ddl 
grep -e "ERROR " $CD/logs/createCALMViews.log>/dev/null
if [ $? -eq 0 ]
then
	MESSAGE=$CRRRDMSGE117
	EXITCODE=$CRRRD4617E
	ACTION=$CRRRDECH041
	rcrdone
fi

$CONNSTR -Dij.outfile=./logs/initCONFIG.log  org.apache.derby.tools.ij ./work_spc/scripts/initCONFIG.sql 
grep -e "ERROR " $CD/logs/initCONFIG.log>/dev/null
if [ $? -eq 0 ]
then
	MESSAGE=$CRRRDMSGE020
	EXITCODE=$CRRRD4520E
	ACTION=$CRRRDECH010
	rcrdone
fi

$CONNSTR -Dij.outfile=./logs/initNF.log  org.apache.derby.tools.ij ./work_spc/scripts/initNF.sql
grep -e "ERROR " $CD/logs/initNF.log>/dev/null
if [ $? -eq 0 ]
then
	MESSAGE=$CRRRDMSGE021
	EXITCODE=$CRRRD4521E
	ACTION=$CRRRDECH011
	rcrdone
fi

$CONNSTR -Dij.outfile=./logs/initRIASSET.log org.apache.derby.tools.ij ./work_spc/scripts/initRIASSET.sql
grep -e " ERROR " $CD/logs/initRIASSET.log>/dev/null
if [ $? -eq 0 ]
then
	MESSAGE=$CRRRDMSGE112
	EXITCODE=$CRRRD4612E
	ACTION=$CRRRDECH038
	rcrdone
fi

$CONNSTR -Dij.outfile=./logs/initRISCHK.log org.apache.derby.tools.ij ./work_spc/scripts/initRISCHK.sql
grep -e " ERROR " $CD/logs/initRISCHK.log>/dev/null
if [ $? -eq 0 ]
then
	MESSAGE=$CRRRDMSGE114
	EXITCODE=$CRRRD4614E
	ACTION=$CRRRDECH040
	rcrdone
fi

$CONNSTR -Dij.outfile=./logs/initSTAR.log  org.apache.derby.tools.ij ./work_spc/scripts/initSTAR.sql 
grep -e "ERROR " $CD/logs/initSTAR.log>/dev/null
if [ $? -eq 0 ]
then
	MESSAGE=$CRRRDMSGE022
	EXITCODE=$CRRRD4522E
	ACTION=$CRRRDECH012
	rcrdone
fi

$CONNSTR -Dij.outfile=./logs/initCALM.log  org.apache.derby.tools.ij ./work_spc/scripts/initCALM.sql 
grep -e "ERROR " $CD/logs/initCALM.log>/dev/null
if [ $? -eq 0 ]
then
	MESSAGE=$CRRRDMSGE109
	EXITCODE=$CRRRD4609E
	ACTION=$CRRRDECH036
	rcrdone
fi

$CONNSTR -Dij.outfile=./logs/star_grants.log org.apache.derby.tools.ij ./work_spc/scripts/star_grants.sql 
grep -e "ERROR " $CD/logs/star_grants.log>/dev/null
if [ $? -eq 0 ]
then
	MESSAGE=$CRRRDMSGE023
	EXITCODE=$CRRRD4523E
	ACTION=$CRRRDECH013
	rcrdone
fi

$CONNSTR -Dij.outfile=./logs/calm_grants.log org.apache.derby.tools.ij ./work_spc/scripts/calm_grants.sql 
grep -e "ERROR " $CD/logs/calm_grants.log>/dev/null
if [ $? -eq 0 ]
then
	MESSAGE=$CRRRDMSGE023
	EXITCODE=$CRRRD4523E
	ACTION=$CRRRDECH013
	rcrdone
fi

java -cp .:$CLASSPATH -Duser="$DBUSER" -Dpasswd="$DBPASSWD" -Ddbms="Derby" -Dalias="$DATA_HOME/$DBNAME" -Dschema="$STAR_SCHEMA" -Dstart="$START_YEAR" -Dend="$END_YEAR" com.ibm.rational.rcpr.dw.procedures.PopulateD_DATE>./logs/populate-D_DATE.log

$CONNSTR -Dij.outfile=./logs/initD_Date.log org.apache.derby.tools.ij ./work_spc/scripts/initD_Date.sql
grep -e "ERROR " $CD/logs/initD_Date.log>/dev/null
if [ $? -eq 0 ]
then
	MESSAGE=$CRRRDMSGE025 
	EXITCODE=$CRRRD4525E 
	ACTION=$CRRRDECH014
	rcrdone
fi

rcrdone


